CREATE OR REPLACE VIEW "customer_all_unlimited" AS
SELECT
      split_part("billing_period", '-', 1) "year"
    , split_part("billing_period", '-', 2) "month"
    , "product_updates"
    , "bill_billing_period_end_date"
    , product['enhanced_networking_supported'] "product_enhanced_networking_supported"
    , "product_maximum_storage_volume"
    , product['operating_system'] "product_operating_system"
    , product['storage'] "product_storage"
    , "product_content_type"
    , product['finding_storage'] "product_finding_storage"
    , "line_item_line_item_description"
    , "reservation_amortized_upfront_fee_for_billing_period"
    , "line_item_normalization_factor"
    , "reservation_start_time"
    , "product_maximum_extended_storage"
    , "savings_plan_used_commitment"
    , "line_item_blended_cost"
    , "product_free_trial"
    , "product_input_mode"
    , "product_gpu"
    , product['physical_processor'] "product_physical_processor"
    , "product_directory_type_description"
    , "product_from_location"
    , product['product_name'] "product_product_name"
    , "product_describes"
    , product['memory'] "product_memory"
    , product['capacitystatus'] "product_capacitystatus"
    , "product_bundle_group"
    , "reservation_recurring_fee_for_usage"
    , product['normalization_size_factor'] "product_normalization_size_factor"
    , "pricing_public_on_demand_rate"
    , "line_item_resource_id"
    , "pricing_lease_contract_length"
    , "product_origin"
    , "line_item_legal_entity"
    , "product_directory_type"
    , product['deployment_option'] "product_deployment_option"
    , "product_resource_type"
    , product['category'] "product_category"
    , product['edition'] "product_edition"
    , "product_directory_size"
    , "line_item_tax_type"
    , "product_instance_name"
    , product['storage_class'] "product_storage_class"
    , "product_standard_storage_retention_included"
    , "product_dominantnondominant"
    , "product_datatransferout"
    , "product_compute_type"
    , "product_physical_cpu"
    , "product_ops_items"
    , "reservation_effective_cost"
    , product['volume_api_name'] "product_volume_api_name"
    , "product_fee_description"
    , product['request_type'] "product_request_type"
    , product['database_engine'] "product_database_engine"
    , "savings_plan_savings_plan_a_r_n"
    , product['queue_type'] "product_queue_type"
    , "product_software_included"
    , "product_request_description"
    , "line_item_availability_zone"
    , "bill_billing_entity"
    , "product_bundle_description"
    , "line_item_usage_account_id"
    , product['processor_features'] "product_processor_features"
    , product['vcpu'] "product_vcpu"
    , "product_enhanced_networking_support"
    , "product_component"
    , product['region'] "product_region"
    , product['finding_source'] "product_finding_source"
    , "line_item_usage_type"
    , product['intel_avx_available'] "product_intel_avx_available"
    , product['dedicated_ebs_throughput'] "product_dedicated_ebs_throughput"
    , product['standard_storage'] "product_standard_storage"
    , "product_sku"
    , "product_free_usage_included"
    , product['max_iopsvolume'] "product_max_iopsvolume"
    , "identity_line_item_id"
    , "product_routing_target"
    , "line_item_line_item_type"
    , "reservation_total_reserved_units"
    , product['group'] "product_group"
    , "line_item_currency_code"
    , product['servicename'] "product_servicename"
    , "pricing_term"
    , "savings_plan_amortized_upfront_commitment_for_billing_period"
    , "savings_plan_savings_plan_effective_cost"
    , "reservation_end_time"
    , product['type'] "product_type"
    , "product_client_location"
    , product['max_throughputvolume'] "product_max_throughputvolume"
    , product['memory_gib'] "product_memory_gib"
    , "product_to_location"
    , "reservation_unused_quantity"
    , "product_granularity"
    , "product_ratetype"
    , product['clock_speed'] "product_clock_speed"
    , "pricing_public_on_demand_cost"
    , "reservation_normalized_units_per_reservation"
    , "product_instances"
    , "product_broker_engine"
    , "product_product_family"
    , product['availability_zone'] "product_availability_zone"
    , product['description'] "product_description"
    , product['processor_architecture'] "product_processor_architecture"
    , "line_item_blended_rate"
    , "product_rootvolume"
    , "product_endpoint_type"
    , "product_routing_type"
    , "pricing_rate_id"
    , product['max_iops_burst_performance'] "product_max_iops_burst_performance"
    , product['transfer_type'] "product_transfer_type"
    , "product_fee_code"
    , "reservation_upfront_value"
    , product['gpu_memory'] "product_gpu_memory"
    , "line_item_operation"
    , "line_item_unblended_cost"
    , "reservation_number_of_reservations"
    , "savings_plan_savings_plan_rate"
    , "bill_payer_account_id"
    , product['memorytype'] "product_memorytype"
    , product['logs_destination'] "product_logs_destination"
    , "reservation_unused_amortized_upfront_fee_for_billing_period"
    , "product_pricing_unit"
    , product['network_performance'] "product_network_performance"
    , "product_servicecode"
    , product['group_description'] "product_group_description"
    , "product_steps"
    , "reservation_modification_status"
    , "reservation_total_reserved_normalized_units"
    , "product_compute_family"
    , product['message_delivery_frequency'] "product_message_delivery_frequency"
    , product['intel_turbo_available'] "product_intel_turbo_available"
    , "reservation_unused_normalized_unit_quantity"
    , "reservation_unused_recurring_fee"
    , "product_traffic_direction"
    , product['availability'] "product_availability"
    , product['ecu'] "product_ecu"
    , "product_insightstype"
    , "product_gets"
    , product['intel_avx2_available'] "product_intel_avx2_available"
    , "reservation_units_per_reservation"
    , "pricing_purchase_option"
    , "reservation_amortized_upfront_cost_for_usage"
    , "line_item_usage_amount"
    , "product_instance_type"
    , product['standard_group'] "product_standard_group"
    , product['event_type'] "product_event_type"
    , "line_item_usage_end_date"
    , product['pre_installed_sw'] "product_pre_installed_sw"
    , product['alarm_type'] "product_alarm_type"
    , "product_location"
    , product['current_generation'] "product_current_generation"
    , "savings_plan_total_commitment_to_date"
    , "bill_bill_type"
    , "product_output_mode"
    , "bill_billing_period_start_date"
    , "product_operation"
    , product['max_volume_size'] "product_max_volume_size"
    , "product_running_mode"
    , "line_item_normalized_usage_amount"
    , "product_license"
    , "savings_plan_recurring_commitment_for_billing_period"
    , "line_item_usage_start_date"
    , "product_physical_gpu"
    , "product_instance_family"
    , "product_instance"
    , product['engine_code'] "product_engine_code"
    , "bill_invoice_id"
    , "product_storage_type"
    , "product_recipient"
    , product['storage_media'] "product_storage_media"
    , "identity_time_interval"
    , product['cache_engine'] "product_cache_engine"
    , product['volume_type'] "product_volume_type"
    , "pricing_offering_class"
    , "product_provisioned"
    , product['license_model'] "product_license_model"
    , product['instance_type_family'] "product_instance_type_family"
    , "line_item_product_code"
    , "product_location_type"
    , "product_usagetype"
    , product['subscription_type'] "product_subscription_type"
    , "line_item_unblended_rate"
    , "product_bundle"
    , product['message_delivery_order'] "product_message_delivery_order"
    , "reservation_subscription_id"
    , "product_cputype"
    , product['durability'] "product_durability"
    , "reservation_reservation_a_r_n"
    , "product_uservolume"
    , "product_from_location_type"
    , "product_to_location_type"
    , product['version'] "product_version"
    , "pricing_currency"
    , "product_minimum_storage_volume"
    , product['tenancy'] "product_tenancy"
    , product['finding_group'] "product_finding_group"
    , product['min_volume_size'] "product_min_volume_size"
    , product['free_query_types'] "product_free_query_types"
    , "pricing_unit"
FROM
    "${cur2_database}"."${cur2_table_name}"
